Index: src/backend/commands/vacuumlazy.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/vacuumlazy.c,v
retrieving revision 1.83
diff -c -r1.83 vacuumlazy.c
*** src/backend/commands/vacuumlazy.c	4 Feb 2007 03:10:55 -0000	1.83
--- src/backend/commands/vacuumlazy.c	5 Feb 2007 17:10:16 -0000
***************
*** 66,71 ****
--- 66,73 ----
  #define REL_TRUNCATE_MINIMUM	1000
  #define REL_TRUNCATE_FRACTION	16
  
+ /* multiplier for acceptable fragmentation before WARNING */
+ #define REL_FRAGMENTATION_FACTOR 5
  
  typedef struct LVRelStats
  {
***************
*** 180,185 ****
--- 182,196 ----
  	/* Update shared free space map with final free space info */
  	lazy_update_fsm(onerel, vacrelstats);
  
+ 	if (vacrelstats->tot_free_pages > MaxFSMPages)
+ 		ereport(WARNING,
+ 				(errmsg("relation \"%s.%s\" contains more than \"max_fsm_pages\" pages with useful free space",
+ 						get_namespace_name(RelationGetNamespace(onerel)),
+ 						RelationGetRelationName(onerel)),
+ 				 errhint("Consider%sincreasing the configuration parameter \"max_fsm_pages\".",
+ 						(REL_FRAGMENTATION_FACTOR * vacrelstats->tot_free_pages > vacrelstats->rel_pages 
+ 							? " using VACUUM FULL on this relation or ": " "))));
+ 
  	/* Update statistics in pg_class */
  	vac_update_relstats(RelationGetRelid(onerel),
  						vacrelstats->rel_pages,
***************
*** 507,519 ****
  					   vacrelstats->tot_free_pages,
  					   empty_pages,
  					   pg_rusage_show(&ru0))));
- 
- 	if (vacrelstats->tot_free_pages > MaxFSMPages)
- 		ereport(WARNING,
- 				(errmsg("relation \"%s.%s\" contains more than \"max_fsm_pages\" pages with useful free space",
- 						get_namespace_name(RelationGetNamespace(onerel)),
- 						relname),
- 				 errhint("Consider using VACUUM FULL on this relation or increasing the configuration parameter \"max_fsm_pages\".")));
  }
  
  
--- 518,523 ----
